# encode and decode are taken from:
# https://stackoverflow.com/questions/2490334/simple-way-to-encode-a-string-according-to-a-password

import base64
def encode(key, clear):
    enc = []
    for i in range(len(clear)):
        key_c = key[i % len(key)]
        enc_c = chr((ord(clear[i]) + ord(key_c)) % 256)
        enc.append(enc_c)
    return base64.urlsafe_b64encode("".join(enc).encode()).decode()

def decode(key, enc):
    dec = []
    enc = base64.urlsafe_b64decode(enc).decode()
    for i in range(len(enc)):
        key_c = key[i % len(key)]
        dec_c = chr((256 + ord(enc[i]) - ord(key_c)) % 256)
        dec.append(dec_c)
    return "".join(dec)

def HoT_example_solution(tasknumbermajor,tasknumbermedium,tasknumberminor):
    taskstring = str(tasknumbermajor)+str(tasknumbermedium)+str(tasknumberminor)
    keyword = input("keyword for Hands-on-Task "+str(tasknumbermajor)+"."+str(tasknumbermedium)+"."+str(tasknumberminor)+":" )
    with open("../hot/encoded/hot"+str(taskstring)+".enc", 'r') as text_file:
        enc_data = text_file.read()
    data = decode(keyword, enc_data)

    with open("../hot/hot"+str(taskstring), "w") as text_file:
        text_file.write(data)
    print("Example solution for Hands-on-Task "+str(tasknumbermajor)+"."+str(tasknumbermedium)+"."+str(tasknumberminor)+" is now accessable. You can load it with '%load ../hot/hot" + str(taskstring) + "'")

if __name__ == "__main__":
    f = open('keys', 'r')
    keys = f.read().splitlines()
    f.close()

    f = open('indices', 'r')
    hotindices = f.read().splitlines()
    f.close()

    for i,key in zip(hotindices,keys) :
        print(i,key)
        with open('plain/hot'+i+'.plain', 'r') as text_file:
            data = text_file.read()

        enc_data = encode(key, data)
        with open("encoded/hot"+i+".enc", "w") as text_file:
            text_file.write(enc_data)
