from ngsolve import *

def AddArtificialDiffusion(a,Ubnd,magnitude):
    if len(a.integrators) > 2:
        print("it seems you already added artificial diffusion - I will not add more")
        return None
        
    fes = a.space
    U,V = fes.TnT()
    Uhat = U.Other(bnd=Ubnd)
    mesh = fes.mesh
    h = specialcf.mesh_size
    n = specialcf.normal(fes.mesh.dim)
    order = fes.globalorder
    diff = magnitude * 0.5 * h / order
    gamma = 10

    def avg(Q):
        return 0.5*Q+0.5*Q.Other()
    
    ints = []
    ints.append(SymbolicBFI (diff * InnerProduct(grad(U),grad(V))))
    ints.append(SymbolicBFI (diff * (- InnerProduct(avg(grad(U))*n,V-V.Other())
                                     - InnerProduct(avg(grad(V))*n,U-Uhat) 
                                     + gamma*order**2/h*InnerProduct(U-Uhat,V-V.Other())), VOL, skeleton=True))
    ints.append(SymbolicBFI (diff * (- InnerProduct(grad(U)*n,V)
                                     - InnerProduct(grad(V)*n,U-Uhat) 
                                     + gamma*order**2/h*InnerProduct(U-Uhat,V)), BND, skeleton=True))
    for integrator in ints:
        a += integrator
